diff --git a/kernel/kernel.mk b/kernel/kernel.mk
index 0f51d4a..5009cb0 100644
--- a/kernel/kernel.mk
+++ b/kernel/kernel.mk
@@ -1,3 +1,94 @@
+################################################################################
+# AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
+# (AMiRo) platform.                                                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
+#                                                                              #
+# This program is free software: you can redistribute it and/or modify         #
+# it under the terms of the GNU General Public License as published by         #
+# the Free Software Foundation, either version 3 of the License, or            #
+# (at your option) any later version.                                          #
+#                                                                              #
+# This program is distributed in the hope that it will be useful,              #
+# but WITHOUT ANY WARRANTY; without even the implied warranty of               #
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                #
+# GNU General Public License for more details.                                 #
+#                                                                              #
+# You should have received a copy of the GNU General Public License            #
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.        #
+#                                                                              #
+# This research/work was supported by the Cluster of Excellence Cognitive      #
+# Interaction Technology 'CITEC' (EXC 277) at Bielefeld University, which is   #
+# funded by the German Research Foundation (DFG).                              #
+################################################################################
+
+
+
 # set kernel path variable
-AMIROOS_KERNEL = $(patsubst %/,%,$(dir $(lastword $(MAKEFILE_LIST))))/ChibiOS
+AMIROOS_KERNEL_DIR := $(dir $(lastword $(MAKEFILE_LIST)))
+
+# set ChibiOS path variable
+CHIBIOS := $(AMIROOS_KERNEL_DIR)ChibiOS
+
+# load licensing files
+include $(CHIBIOS)/os/license/license.mk
+
+# load startup files
+## must be loaded by each module individually
+
+# load HAL-OSAL files
+include $(CHIBIOS)/os/hal/hal.mk
+## platform.mk must be loaded by each module individually
+include $(CHIBIOS)/os/hal/osal/rt/osal.mk
+include $(CHIBIOS)/os/hal/lib/streams/streams.mk
+
+# load RTOS files
+include $(CHIBIOS)/os/rt/rt.mk
+## compiler port must be loaded by each module individually
+
+## load auto-build files in ./source recursively.
+#include $(CHIBIOS)/tools/mk/autobuild.mk
+
+# load test files
+include $(CHIBIOS)/test/lib/test.mk
+include $(CHIBIOS)/test/rt/rt_test.mk
+include $(CHIBIOS)/test/oslib/oslib_test.mk
+
+# include paths
+AMIROOS_KERNEL_INC = $(ALLINC) \
+                     $(TESTINC) \
+                     $(CHIBIOS)/os/hal/lib/streams
+
+# C source files
+AMIROOS_KERNEL_CSRC = $(ALLCSRC) \
+                      $(CHIBIOS)/os/various/syscalls.c \
+                      $(CHIBIOS)/os/various/evtimer.c \
+                      $(TESTSRC)
+
+# C++ source files
+AMIROOS_KERNEL_CPPSRC = $(ALLCPPSRC) \
+                        $(CHIBIOS)/os/various/cpp_wrappers/syscalls_cpp.cpp
+
+# ASM source files
+AMIROOS_KERNEL_ASMSRC = $(ALLASMSRC)
+
+# ASM with preprocessor source files
+AMIROOS_KERNEL_ASMXSRC = $(ALLXASMSRC)
+
+### Information forwarded to ChibiOS ###
+# Inclusion directories.
+INCDIR = $(AMIROOS_INC)
+
+# C sources that can be compiled in ARM or THUMB mode depending on the global
+# setting.
+CSRC = $(AMIROOS_CSRC)
+
+# C++ sources that can be compiled in ARM or THUMB mode depending on the global
+# setting.
+CPPSRC = $(AMIROOS_CPPSRC)
+
+# List ASM source files here.
+ASMSRC = $(AMIROOS_ASMSRC)
+
+# List ASM with preprocessor source files here.
+ASMXSRC = $(AMIROOS_ASMXSRC)
 
diff --git a/modules/DiWheelDrive_1-1/Makefile b/modules/DiWheelDrive_1-1/Makefile
index 2218186..f623128 100644
--- a/modules/DiWheelDrive_1-1/Makefile
+++ b/modules/DiWheelDrive_1-1/Makefile
@@ -112,100 +112,71 @@ endif
 # Project, target, sources and paths                                           #
 #                                                                              #
 
-# Absolute path to the project
-PROJECT_PATH := $(abspath $(dir $(abspath $(lastword $(MAKEFILE_LIST)))))
+# Absolute path to the project.
+PROJECT_PATH := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
 
-# Define project name here
-PROJECT := $(patsubst $(abspath $(dir $(abspath $(lastword $(MAKEFILE_LIST))))..)/%,%,$(PROJECT_PATH))
+# Project name.
+PROJECT := $(notdir $(PROJECT_PATH))
 
 # Target settings.
-MCU = cortex-m3
+MCU := cortex-m3
 
-# Imported source files and paths.
-include ../../kernel/kernel.mk
-CHIBIOS    := $(AMIROOS_KERNEL)
-CONFDIR    := .
+# Module specific paths and directories.
+MODULEDIR := .
+CONFDIR := $(MODULEDIR)
 ifeq ($(BUILDDIR),)
   BUILDDIR := $(PROJECT_PATH)/build
 endif
-DEPDIR     := $(dir $(BUILDDIR)).dep
-AMIROOS    := ../..
-# Licensing files.
-include $(CHIBIOS)/os/license/license.mk
-# Startup files.
+DEPDIR := $(dir $(BUILDDIR)).dep
+
+# Linker script.
+LDSCRIPT= STM32F103xE.ld
+
+# General AMiRo-OS files.
+include ../../amiroos.mk
+
+# Module specific ChibiOS files.
 include $(CHIBIOS)/os/common/startup/ARMCMx/compilers/GCC/mk/startup_stm32f1xx.mk
-# HAL-OSAL files (optional).
-include $(CHIBIOS)/os/hal/hal.mk
 include $(CHIBIOS)/os/hal/ports/STM32/STM32F1xx/platform.mk
-include $(CHIBIOS)/os/hal/osal/rt/osal.mk
-include $(CHIBIOS)/os/hal/lib/streams/streams.mk
-# RTOS files (optional).
-include $(CHIBIOS)/os/rt/rt.mk
 include $(CHIBIOS)/os/common/ports/ARMCMx/compilers/GCC/mk/port_v7m.mk
-# Auto-build files in ./source recursively.
-include $(CHIBIOS)/tools/mk/autobuild.mk
-# Other files (optional).
-include $(CHIBIOS)/test/lib/test.mk
-include $(CHIBIOS)/test/rt/rt_test.mk
-include $(CHIBIOS)/test/oslib/oslib_test.mk
-# AMiRo-BLT files
-include ../../bootloader/bootloader.mk
-# AMiRo-LLD files
-include ../../periphery-lld/periphery-lld.mk
-# AMiRo-OS files
-include ../modules.mk
-include $(AMIROOS)/core/core.mk
-include $(AMIROOS)/unittests/unittests.mk
-
-# Define linker script file here
-LDSCRIPT= STM32F103xE.ld
 
-# C sources that can be compiled in ARM or THUMB mode depending on the global
-# setting.
-CSRC = $(ALLCSRC) \
-       $(CHIBIOS)/os/various/syscalls.c \
-       $(CHIBIOS)/os/various/evtimer.c \
-       $(TESTSRC) \
-       board.c \
-       $(PERIPHERYLLDCSRC) \
-       $(UNITTESTSCSRC) \
-       $(AMIROOSCORECSRC) \
-       $(MODULESCSRC) \
-       module.c \
-       $(APPSCSRC)
-
-# C++ sources that can be compiled in ARM or THUMB mode depending on the global
-# setting.
-CPPSRC = $(ALLCPPSRC) \
-         $(CHIBIOS)/os/various/cpp_wrappers/syscalls_cpp.cpp \
-         $(AMIROOSCORECPPSRC) \
-         $(APPSCPPSRC)
-
-# List ASM source files here.
-ASMSRC = $(ALLASMSRC) \
-         $(APPSASMSRC)
-
-# List ASM with preprocessor source files here.
-ASMXSRC = $(ALLXASMSRC) \
-          $(APPSASMXSRC)
-
-# Inclusion directories.
-INCDIR = $(CONFDIR) \
-         $(ALLINC) \
-         $(TESTINC) \
-         $(CHIBIOS)/os/hal/lib/streams \
-         $(BOOTLOADERINC) \
-         $(PERIPHERYLLDINC) \
-         $(AMIROOS) \
-         $(UNITTESTSINC) \
-         $(AMIROOSCOREINC) \
-         $(MODULESINC) \
-         $(APPSINC)
-
-# Define C warning options here.
+# Periphery LLDs.
+AMIROOS_PERIPHERYLLD_INC += $(AMIROLLD)/drivers/A3906/v1 \
+                            $(AMIROLLD)/drivers/AT24C01B/v1 \
+                            $(AMIROLLD)/drivers/HMC5883L/v1 \
+                            $(AMIROLLD)/drivers/INA219/v1 \
+                            $(AMIROLLD)/drivers/L3G4200D/v1 \
+                            $(AMIROLLD)/drivers/LED/v1 \
+                            $(AMIROLLD)/drivers/LIS331DLH/v1 \
+                            $(AMIROLLD)/drivers/LTC4412/v1 \
+                            $(AMIROLLD)/drivers/PCA9544A/v1 \
+                            $(AMIROLLD)/drivers/TPS6211x/v1 \
+                            $(AMIROLLD)/drivers/VCNL4020/v1
+
+# Tests.
+AMIROOS_TEST_INC += $(AMIROOS_TEST_DIR)periphery-lld/A3906_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/AT24C01B_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/HMC5883L_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/INA219_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/L3G4200D_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/LED_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/LIS331DLH_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/LTC4412_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/PCA9544A_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/TPS6211x_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/VCNL4020_v1
+
+# Module specific inclusion directories
+MODULE_INC = $(MODULEDIR) \
+             $(wildcard $(MODULEDIR)/test/*)
+
+# Module specific C source files.
+MODULE_CSRC = $(wildcard $(MODULE_INC:%=%/*.[Cc]))
+
+# C warning options.
 CWARN = -Wall -Wextra -Wundef -Wstrict-prototypes
 
-# Define C++ warning options here.
+# C++ warning options.
 CPPWARN = -Wall -Wextra -Wundef
 
 # Create an additional .srec image file.
diff --git a/modules/DiWheelDrive_1-1/alldconf.h b/modules/DiWheelDrive_1-1/alldconf.h
index 9a2c97b..a9d0072 100644
--- a/modules/DiWheelDrive_1-1/alldconf.h
+++ b/modules/DiWheelDrive_1-1/alldconf.h
@@ -43,61 +43,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define AMIROLLD_CFG_TIME_SIZE                  32
 
-/**
- * @brief   Enable flag for the A3906 motor driver.
- */
-#define AMIROLLD_CFG_A3906                      1
-
-/**
- * @brief   Enable flag for the AT24C01BN-SH-B EEPROM.
- */
-#define AMIROLLD_CFG_AT24C01B                   1
-
-/**
- * @brief   Enable flag for the MHC5883L compass.
- */
-#define AMIROLLD_CFG_HMC5883L                   1
-
-/**
- * @brief   Enable flag for the INA219 power monitor.
- */
-#define AMIROLLD_CFG_INA219                     1
-
-/**
- * @brief   Enable flag for the L3G4200D gyroscope.
- */
-#define AMIROLLD_CFG_L3G4200D                   1
-
-/**
- * @brief   Enable flag for the status LED.
- */
-#define AMIROLLD_CFG_LED                        1
-
-/**
- * @brief   Enable flag for the LIS331DLH accelerometer.
- */
-#define AMIROLLD_CFG_LIS331DLH                  1
-
-/**
- * @brief   Enable flag for the LTC4412 power path controller.
- */
-#define AMIROLLD_CFG_LTC4412                    1
-
-/**
- * @brief   Enable flag for the PCA9544A I2C multiplexer.
- */
-#define AMIROLLD_CFG_PCA9544A                   1
-
-/**
- * @brief   Enable flag for the TPS62113 step-down converter.
- */
-#define AMIROLLD_CFG_TPS6211x                   1
-
-/**
- * @brief   Enable flag for the VCNL4020 proximity sensor.
- */
-#define AMIROLLD_CFG_VCNL4020                   1
-
 #endif /* ALLDCONF_H */
 
 /** @} */
diff --git a/modules/DiWheelDrive_1-1/halconf.h b/modules/DiWheelDrive_1-1/halconf.h
index 6bee851..dc2d320 100644
--- a/modules/DiWheelDrive_1-1/halconf.h
+++ b/modules/DiWheelDrive_1-1/halconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define _CHIBIOS_HAL_CONF_
 #define _CHIBIOS_HAL_CONF_VER_7_0_
 
-#include "mcuconf.h"
+#include <mcuconf.h>
 
 /**
  * @brief   Enables the PAL subsystem.
diff --git a/modules/DiWheelDrive_1-1/module.c b/modules/DiWheelDrive_1-1/module.c
index 77f7e43..0cf6a90 100644
--- a/modules/DiWheelDrive_1-1/module.c
+++ b/modules/DiWheelDrive_1-1/module.c
@@ -145,7 +145,7 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
   /* meta */ {
     /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
-    /* active state   */ LED_LLD_GPIO_ACTIVE_STATE,
+    /* active state   */ APAL_GPIO_ACTIVE_LOW,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
@@ -415,383 +415,201 @@ VCNL4020Driver moduleLldProximity = {
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
-#include <string.h>
 
 /*
  * A3906 (motor driver)
  */
-static int _utShellCmdCb_AlldA3906(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_A3906.h>
+static int _testA3906ShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldA3906, NULL);
-  return AOS_OK;
+  return moduleTestA3906ShellCb(stream, argc, argv, NULL);
 }
-static ut_a3906data_t _utA3906Data = {
-  /* driver           */ &moduleLldMotors,
-  /* PWM information  */ {
-    /* driver   */ &MODULE_HAL_PWM_DRIVE,
-    /* channels */ {
-      /* left wheel forward   */ MODULE_HAL_PWM_DRIVE_CHANNEL_LEFT_FORWARD,
-      /* left wheel backward  */ MODULE_HAL_PWM_DRIVE_CHANNEL_LEFT_BACKWARD,
-      /* right wheel forward  */ MODULE_HAL_PWM_DRIVE_CHANNEL_RIGHT_FORWARD,
-      /* right wheel backward */ MODULE_HAL_PWM_DRIVE_CHANNEL_RIGHT_BACKWARD,
-    },
-  },
-  /* QEI information  */ {
-    /* left wheel               */ &MODULE_HAL_QEI_LEFT_WHEEL,
-    /* right wheel              */ &MODULE_HAL_QEI_RIGHT_WHEEL,
-    /* increment per revolution */ MODULE_HAL_QEI_INCREMENTS_PER_REVOLUTION,
-  },
-  /* Wheel diameter   */ {
-    /* left wheel   */ 0.05571f,
-    /* right wheel  */ 0.05571f,
-  },
-  /* timeout          */ 10 * MICROSECONDS_PER_SECOND,
-};
-aos_unittest_t moduleUtAlldA3906  = {
-  /* name           */ "A3906",
-  /* info           */ "motor driver",
-  /* test function  */ utAlldA3906Func,
-  /* shell command  */ {
-    /* name     */ "unittest:MotorDriver",
-    /* callback */ _utShellCmdCb_AlldA3906,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utA3906Data,
-};
+AOS_SHELL_COMMAND(moduleTestA3906ShellCmd, "test:MotorDriver", _testA3906ShellCmdCb);
 
 /*
- * AT24C01B (EEPROM)
+ * AT24C01BN-SH-B (EEPROM)
  */
-static int _utShellCmdCb_AlldAt24c01b(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_AT24C01B.h>
+static int _testAt24co1bShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldAt24c01b, NULL);
-  return AOS_OK;
+  return moduleTestAt24c01bShellCb(stream, argc, argv, NULL);
 }
-static ut_at24c01bdata_t _utAlldAt24c01bData = {
-  /* driver   */ &moduleLldEeprom,
-  /* timeout  */ MICROSECONDS_PER_SECOND,
-};
-aos_unittest_t moduleUtAlldAt24c01b = {
-  /* name           */ "AT24C01B",
-  /* info           */ "1kbit EEPROM",
-  /* test function  */ utAlldAt24c01bFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:EEPROM",
-    /* callback */ _utShellCmdCb_AlldAt24c01b,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utAlldAt24c01bData,
-};
+AOS_SHELL_COMMAND(moduleTestAt24c01bShellCmd, "test:EEPROM", _testAt24co1bShellCmdCb);
 
 /*
  * HMC5883L (compass)
  */
-static int _utShellCmdCb_AlldHmc5883l(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_HMC5883L.h>
+static int _testHmc5883lShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldHmc5883l, NULL);
-  return AOS_OK;
+  return moduleTestHmc5883lShellCb(stream, argc, argv, NULL);
 }
-static ut_hmc5883ldata_t _utHmc5883lData = {
-  /* HMC driver   */ &moduleLldCompass,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_COMPASSDRDY,
-  /* timeout      */ MICROSECONDS_PER_SECOND,
-};
-aos_unittest_t moduleUtAlldHmc5883l = {
-  /* name           */ "HMC5883L",
-  /* info           */ "compass",
-  /* test function  */ utAlldHmc5883lFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:Compass",
-    /* callback */ _utShellCmdCb_AlldHmc5883l,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utHmc5883lData,
-};
+AOS_SHELL_COMMAND(moduleTestHmc5883lShellCmd, "test:Compass", _testHmc5883lShellCmdCb);
 
 /*
  * INA219 (power monitor)
  */
-static int _utShellCmdCb_AlldIna219(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_INA219.h>
+static int _testIna219ShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldIna219, "VDD (3.3V)");
-  return AOS_OK;
+  return moduleTestIna219ShellCb(stream, argc, argv, NULL);
 }
-static ut_ina219data_t _utIna219Data = {
-  /* driver           */ &moduleLldPowerMonitorVdd,
-  /* expected voltage */ 3.3f,
-  /* tolerance        */ 0.05f,
-  /* timeout */ MICROSECONDS_PER_SECOND,
-};
-aos_unittest_t moduleUtAlldIna219 = {
-  /* name           */ "INA219",
-  /* info           */ "power monitor",
-  /* test function  */ utAlldIna219Func,
-  /* shell command  */ {
-    /* name     */ "unittest:PowerMonitor",
-    /* callback */ _utShellCmdCb_AlldIna219,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utIna219Data,
-};
+AOS_SHELL_COMMAND(moduleTestIna219ShellCmd, "test:PowerMonitor", _testIna219ShellCmdCb);
 
 /*
  * L3G4200D (gyroscope)
  */
-static int _utShellCmdCb_AlldL3g4200d(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_L3G4200D.h>
+static int _testL3g4200dShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  spiStart(((ut_l3g4200ddata_t*)moduleUtAlldL3g4200d.data)->l3gd->spid, ((ut_l3g4200ddata_t*)moduleUtAlldL3g4200d.data)->spiconf);
-  aosUtRun(stream, &moduleUtAlldL3g4200d, NULL);
-  spiStop(((ut_l3g4200ddata_t*)moduleUtAlldL3g4200d.data)->l3gd->spid);
-  return AOS_OK;
+  return moduleTestL3g4200dShellCb(stream, argc, argv, NULL);
 }
-static ut_l3g4200ddata_t _utL3g4200dData = {
-  /* driver            */ &moduleLldGyroscope,
-  /* SPI configuration */ &moduleHalSpiGyroscopeConfig,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_GYRODRDY,
-};
-aos_unittest_t moduleUtAlldL3g4200d = {
-  /* name           */ "L3G4200D",
-  /* info           */ "Gyroscope",
-  /* test function  */ utAlldL3g4200dFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:Gyroscope",
-    /* callback */ _utShellCmdCb_AlldL3g4200d,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utL3g4200dData,
-};
+AOS_SHELL_COMMAND(moduleTestL3g4200dShellCmd, "test:Gyroscope", _testL3g4200dShellCmdCb);
 
 /*
  * Status LED
  */
-static int _utShellCmdCb_AlldLed(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_LED.h>
+static int _testLedShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldLed, NULL);
-  return AOS_OK;
+  return moduleTestLedShellCb(stream, argc, argv, NULL);
 }
-aos_unittest_t moduleUtAlldLed = {
-  /* name           */ "LED",
-  /* info           */ NULL,
-  /* test function  */ utAlldLedFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:StatusLED",
-    /* callback */ _utShellCmdCb_AlldLed,
-    /* next     */ NULL,
-  },
-  /* data           */ &moduleLldStatusLed,
-};
+AOS_SHELL_COMMAND(moduleTestLedShellCmd, "test:StatusLED", _testLedShellCmdCb);
 
 /*
  * LIS331DLH (accelerometer)
  */
-static int _utShellCmdCb_AlldLis331dlh(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_LIS331DLH.h>
+static int _testLis331dlhShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  spiStart(((ut_lis331dlhdata_t*)moduleUtAlldLis331dlh.data)->lisd->spid, ((ut_lis331dlhdata_t*)moduleUtAlldLis331dlh.data)->spiconf);
-  aosUtRun(stream, &moduleUtAlldLis331dlh, NULL);
-  spiStop(((ut_lis331dlhdata_t*)moduleUtAlldLis331dlh.data)->lisd->spid);
-  return AOS_OK;
+  return moduleTestLis331dlhShellCb(stream, argc, argv, NULL);
 }
-static ut_lis331dlhdata_t _utLis331dlhData = {
-  /* driver            */ &moduleLldAccelerometer,
-  /* SPI configuration */ &moduleHalSpiAccelerometerConfig,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_ACCELINT,
-};
-aos_unittest_t moduleUtAlldLis331dlh = {
-  /* name           */ "LIS331DLH",
-  /* info           */ "Accelerometer",
-  /* test function  */ utAlldLis331dlhFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:Accelerometer",
-    /* callback */ _utShellCmdCb_AlldLis331dlh,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utLis331dlhData,
-};
+AOS_SHELL_COMMAND(moduleTestLis331dlhShellCmd, "test:Accelerometer", _testLis331dlhShellCmdCb);
 
 /*
  * LTC4412 (power path controller)
  */
-static int _utShellCmdCb_AlldLtc4412(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_LTC4412.h>
+static int _testLtc4412ShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldLtc4412, NULL);
-  return AOS_OK;
+  return moduleTestLtc4412ShellCb(stream, argc, argv, NULL);
 }
-aos_unittest_t moduleUtAlldLtc4412 = {
-  /* name           */ "LTC4412",
-  /* info           */ "Power path controller",
-  /* test function  */ utAlldLtc4412Func,
-  /* shell command  */ {
-    /* name     */ "unittest:PowerPathController",
-    /* callback */ _utShellCmdCb_AlldLtc4412,
-    /* next     */ NULL,
-  },
-  /* data           */ &moduleLldPowerPathController,
-};
+AOS_SHELL_COMMAND(moduleTestLtc4412ShellCmd, "test:PowerPathController", _testLtc4412ShellCmdCb);
 
 /*
  * PCA9544A (I2C multiplexer)
  */
-static int _utShellCmdCb_AlldPca9544a(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_PCA9544A.h>
+static int _testPca9544aShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldPca9544a, NULL);
-  return AOS_OK;
+  return moduleTestPca9544aShellCb(stream, argc, argv, NULL);
 }
-static ut_pca9544adata_t _utPca9544aData = {
-  /* driver  */ &moduleLldI2cMultiplexer,
-  /* timeout */ MICROSECONDS_PER_SECOND,
-};
-aos_unittest_t moduleUtAlldPca9544a = {
-  /* name           */ "PCA9544A",
-  /* info           */ "I2C multiplexer",
-  /* test function  */ utAlldPca9544aFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:I2CMultiplexer",
-    /* callback */ _utShellCmdCb_AlldPca9544a,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utPca9544aData,
-};
+AOS_SHELL_COMMAND(moduleTestPca9544aShellCmd, "test:I2CMultiplexer", _testPca9544aShellCmdCb);
 
 /*
  * TPS62113 (step-down converter)
  */
-static int _utShellCmdCb_AlldTps62113(BaseSequentialStream* stream, int argc, char* argv[])
+#include <module_test_TPS6211x.h>
+static int _testTps6211xShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  (void)argc;
-  (void)argv;
-  aosUtRun(stream, &moduleUtAlldTps62113, NULL);
-  return AOS_OK;
+  return moduleTestTps6211xShellCb(stream, argc, argv, NULL);
 }
-aos_unittest_t moduleUtAlldTps62113 = {
-  /* name           */ "TPS62113",
-  /* info           */ "Step down converter",
-  /* test function  */ utAlldTps6211xFunc,
-  /* shell command  */ {
-    /* name     */ "unittest:StepDownConverter",
-    /* callback */ _utShellCmdCb_AlldTps62113,
-    /* next     */ NULL,
-  },
-  /* data           */ &moduleLldStepDownConverterVdrive,
-};
+AOS_SHELL_COMMAND(moduleTestTps62113ShellCmd, "test:StepDownConverter", _testTps6211xShellCmdCb);
 
 /*
  * VCNL4020 (proximity sensor)
  */
-static void _utAlldVcnl4020_disableInterrupt(VCNL4020Driver* vcnl)
+#include <module_test_VCNL4020.h>
+static int _testVcnl4020ShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  uint8_t intstatus;
-  vcnl4020_lld_writereg(vcnl, VCNL4020_LLD_REGADDR_INTCTRL, 0, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-  vcnl4020_lld_readreg(vcnl, VCNL4020_LLD_REGADDR_INTSTATUS, &intstatus, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-  if (intstatus) {
-    vcnl4020_lld_writereg(vcnl, VCNL4020_LLD_REGADDR_INTSTATUS, intstatus, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-  }
-  return;
+  return moduleTestVcnl4020ShellCb(stream, argc, argv, NULL);
 }
-static int _utShellCmdCb_AlldVcnl4020(BaseSequentialStream* stream, int argc, char* argv[])
+AOS_SHELL_COMMAND(moduleTestVcnl4020ShellCmd, "test:ProximitySensor", _testVcnl4020ShellCmdCb);
+
+/*
+ * entire module
+ */
+static int _testAllShellCmdCb(BaseSequentialStream* stream, int argc, char* argv[])
 {
-  enum {
-    UNKNOWN,
-    FL, FR, WL, WR,
-  } sensor = UNKNOWN;
-  // evaluate arguments
-  if (argc == 2) {
-    if (strcmp(argv[1], "--frontleft") == 0 || strcmp(argv[1], "-fl") == 0) {
-      sensor = FL;
-    } else if (strcmp(argv[1], "--frontright") == 0 || strcmp(argv[1], "-fr") == 0) {
-      sensor = FR;
-    } else if (strcmp(argv[1], "--wheelleft") == 0 || strcmp(argv[1], "-wl") == 0) {
-      sensor = WL;
-    } else if (strcmp(argv[1], "--wheelright") == 0 || strcmp(argv[1], "-wr") == 0) {
-      sensor = WR;
-    }
-  }
-  if (sensor != UNKNOWN) {
-    pca9544a_lld_setchannel(&moduleLldI2cMultiplexer, PCA9544A_LLD_CH0, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-    _utAlldVcnl4020_disableInterrupt(((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->vcnld);
-    pca9544a_lld_setchannel(&moduleLldI2cMultiplexer, PCA9544A_LLD_CH1, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-    _utAlldVcnl4020_disableInterrupt(((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->vcnld);
-    pca9544a_lld_setchannel(&moduleLldI2cMultiplexer, PCA9544A_LLD_CH2, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-    _utAlldVcnl4020_disableInterrupt(((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->vcnld);
-    pca9544a_lld_setchannel(&moduleLldI2cMultiplexer, PCA9544A_LLD_CH3, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-    _utAlldVcnl4020_disableInterrupt(((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->vcnld);
-    switch (sensor) {
-      case FL:
-        pca9544a_lld_setchannel(&moduleLldI2cMultiplexer, PCA9544A_LLD_CH3, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-        aosUtRun(stream, &moduleUtAlldVcnl4020, "front left sensor");
-        break;
-      case FR:
-        pca9544a_lld_setchannel(&moduleLldI2cMultiplexer, PCA9544A_LLD_CH0, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-        aosUtRun(stream, &moduleUtAlldVcnl4020, "front right sensor");
-        break;
-      case WL:
-        pca9544a_lld_setchannel(&moduleLldI2cMultiplexer, PCA9544A_LLD_CH2, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-        aosUtRun(stream, &moduleUtAlldVcnl4020, "left wheel sensor");
-        break;
-      case WR:
-        pca9544a_lld_setchannel(&moduleLldI2cMultiplexer, PCA9544A_LLD_CH1, ((ut_vcnl4020data_t*)moduleUtAlldVcnl4020.data)->timeout);
-        aosUtRun(stream, &moduleUtAlldVcnl4020, "right wheel sensor");
-        break;
-      default:
-        break;
-    }
-    return AOS_OK;
-  }
-  // print help
-  chprintf(stream, "Usage: %s OPTION\n", argv[0]);
-  chprintf(stream, "Options:\n");
-  chprintf(stream, "  --frontleft, -fl\n");
-  chprintf(stream, "    Test front left proximity sensor.\n");
-  chprintf(stream, "  --frontrigt, -fr\n");
-  chprintf(stream, "    Test front right proximity sensor.\n");
-  chprintf(stream, "  --wheelleft, -wl\n");
-  chprintf(stream, "    Test left wheel proximity sensor.\n");
-  chprintf(stream, "  --wheelright, -wr\n");
-  chprintf(stream, "    Test right wheel proximity sensor.\n");
-  return AOS_INVALIDARGUMENTS;
+  (void)argc;
+  (void)argv;
+
+  int status = AOS_OK;
+  char* targv[AMIROOS_CFG_SHELL_MAXARGS] = {NULL};
+  aos_testresult_t result_test = {0, 0};
+  aos_testresult_t result_total = {0, 0};
+
+  /* A3906 (motor driver) */
+  status |= moduleTestA3906ShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* AT24C01B (EEPROM) */
+  status |= moduleTestAt24c01bShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* HMC5883L (compass) */
+  status |= moduleTestHmc5883lShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* INA219 (power monitor) */
+  status |= moduleTestIna219ShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* L3G4200D (gyroscope) */
+  status |= moduleTestL3g4200dShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* Status LED */
+  status |= moduleTestLedShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* LIS331DLH (accelerometer) */
+  status |= moduleTestLis331dlhShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* LTC4412 (power path controller) */
+  status |= moduleTestLtc4412ShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* PCA9544A (I2C multiplexer) */
+  status |= moduleTestPca9544aShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* TPS62113 (step-down converter) */
+  status |= moduleTestTps6211xShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+
+  /* VCNL4020 (proximity sensor) */
+  // wheel left
+  targv[1] = "-wl";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // front left
+  targv[1] = "-fl";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // front right
+  targv[1] = "-fr";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  // wheel right
+  targv[1] = "-wr";
+  status |= moduleTestVcnl4020ShellCb(stream, 2, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+  targv[1] = "";
+
+  // print total result
+  chprintf(stream, "\n");
+  aosTestResultPrintSummary(stream, &result_total, "entire module");
+
+  return status;
 }
-static ut_vcnl4020data_t _utVcnl4020Data = {
-  /* driver       */ &moduleLldProximity,
-  /* timeout      */ MICROSECONDS_PER_SECOND,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_IRINT,
-};
-aos_unittest_t moduleUtAlldVcnl4020 = {
-  /* name           */ "VCNL4020",
-  /* info           */ "proximity sensor",
-  /* test function  */ utAlldVcnl4020Func,
-  /* shell command  */ {
-    /* name     */ "unittest:Proximity",
-    /* callback */ _utShellCmdCb_AlldVcnl4020,
-    /* next     */ NULL,
-  },
-  /* data           */ &_utVcnl4020Data,
-};
+AOS_SHELL_COMMAND(moduleTestAllShellCmd, "test:all", _testAllShellCmdCb);
 
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
